Osmocom logging framework

## Files

file | logging.h
file | logging_syslog.c
file | loggingrb.c

## Data Structures

struct | log_category
struct | log_info_cat
| Information regarding one logging category. More...
struct | log_context
| Log context information, passed to filter. More...
struct | log_info
| Logging configuration, passed to log_init. More...
struct | log_target
| structure representing a logging target More...

## Macros

#define | LOG_MAX_CTX 8
| Maximum number of logging contexts.
#define | LOG_MAX_FILTERS 8
| Maximum number of logging filters.
#define | DEBUG
#define | DEBUGP(ss, fmt, args...) logp(ss, __FILE__, __LINE__, 0, fmt, ## args)
#define | DEBUGPC(ss, fmt, args...) logp(ss, __FILE__, __LINE__, 1, fmt, ## args)
#define | LOGP(ss, level, fmt, args...) logp2(ss, level, __FILE__, __LINE__, 0, fmt, ##args)
| Log a new message through the Osmocom logging framework. More...
#define | LOGPC(ss, level, fmt, args...) logp2(ss, level, __FILE__, __LINE__, 1, fmt, ##args)
| Continue a log message through the Osmocom logging framework. More...
#define | LOGL_DEBUG 1
| different log levels More...
#define | LOGL_INFO 3
#define | LOGL_NOTICE 5
| abnormal/unexpected condition
#define | LOGL_ERROR 7
| error condition, requires user action
#define | LOGL_FATAL 8
| fatal, program aborted
#define | LOG_FILTER_ALL 0x0001
#define | DLGLOBAL -1
#define | DLLAPD -2
#define | DLINP -3
#define | DLMUX -4
#define | DLMI -5
#define | DLMIB -6
#define | DLSMS -7
#define | DLCTRL -8
#define | DLGTP -9
#define | DLSTATS -10
#define | OSMO_NUM_DLIB 10

## Typedefs

typedef int | log_filter(const struct log_context *ctx, struct log_target *target)
| Log filter function.
typedef void | log_print_filters(struct vty *vty, const struct log_info *info, const struct log_target *tgt)
typedef void | log_save_filters(struct vty *vty, const struct log_info *info, const struct log_target *tgt)

## Enumerations

enum | log_target_type { LOG_TGT_TYPE_VTY, LOG_TGT_TYPE_SYSLOG, LOG_TGT_TYPE_FILE, LOG_TGT_TYPE_STDERR, LOG_TGT_TYPE_STRRB }
| Type of logging target. More...

## Functions

void | osmo_vlogp (int subsys, int level, const char *file, int line, int cont, const char *format, va_list ap)
| vararg version of logging function
void | logp (int subsys, const char *file, int line, int cont, const char *format,...) __attribute__((format(printf
void | logp2 (int subsys, unsigned int level, const char *file, int line, int cont, const char *format,...) __attribute__((format(printf
void int | log_init (const struct log_info *inf, void *talloc_ctx)
| Initialize the Osmocom logging core. More...
void | log_reset_context (void)
| Reset (clear) the logging context.
int | log_set_context (uint8_t ctx, void *value)
| Set the logging context. More...
void | log_set_all_filter (struct log_target *target, int)
| Enable the LOG_FILTER_ALL log filter. More...
void | log_set_use_color (struct log_target *target, int)
| Enable or disable the use of colored output. More...
void | log_set_print_extended_timestamp (struct log_target *target, int)
| Enable or disable printing of extended timestamps while logging. More...
void | log_set_print_timestamp (struct log_target *target, int)
| Enable or disable printing of timestamps while logging. More...
void | log_set_print_filename (struct log_target *target, int)
| Enable or disable printing of the filename while logging. More...
void | log_set_print_category (struct log_target *target, int)
| Enable or disable printing of the category name. More...
void | log_set_log_level (struct log_target *target, int log_level)
| Set the global log level for a given log target. More...
void | log_parse_category_mask (struct log_target *target, const char *mask)
| parse the log category mask More...
int | log_parse_level (const char *lvl)
| Parse a human-readable log level into a numeric value.
const char * | log_level_str (unsigned int lvl)
| convert a numeric log level into human-readable string
int | log_parse_category (const char *category)
| parse a human-readable log category into numeric form More...
void | log_set_category_filter (struct log_target *target, int category, int enable, int level)
| Set a category filter on a given log target. More...
struct log_target * | log_target_create (void)
| Create a new log target skeleton.
void | log_target_destroy (struct log_target *target)
| Unregister, close and delete a log target.
struct log_target * | log_target_create_stderr (void)
| Create the STDERR log target.
struct log_target * | log_target_create_file (const char *fname)
| Create a new file-based log target. More...
struct log_target * | log_target_create_syslog (const char *ident, int option, int facility)
| Create a new logging target for syslog logging. More...
int | log_target_file_reopen (struct log_target *tgt)
| close and re-open a log file (for log file rotation)
int | log_targets_reopen (void)
| close and re-open a log file (for log file rotation)
void | log_add_target (struct log_target *target)
| Register a new log target with the logging core. More...
void | log_del_target (struct log_target *target)
| Unregister a log target from the logging core. More...
const char * | log_vty_command_string (const struct log_info *info)
| Generates the logging command string for VTY. More...
const char * | log_vty_command_description (const struct log_info *info)
| Generates the logging command description for VTY. More...
struct log_target * | log_target_find (int type, const char *fname)
| Find a registered log target. More...
static int | logp2syslog_level (unsigned int level)
static void | _syslog_output (struct log_target *target, unsigned int level, const char *log)
static void | _rb_output (struct log_target *target, unsigned int level, const char *log)
size_t | log_target_rb_used_size (struct log_target const *target)
| Return the number of log strings in the osmo_strrb-backed target. More...
size_t | log_target_rb_avail_size (struct log_target const *target)
| Return the capacity of the osmo_strrb-backed target. More...
const char * | log_target_rb_get (struct log_target const *target, size_t logindex)
| Return the nth log entry in a target. More...
struct log_target * | log_target_create_rb (size_t size)
| Create a new logging target for ringbuffer-backed logging. More...

## Variables

struct llist_head | osmo_log_target_list

## Detailed Description

## Macro Definition Documentation

#define LOGL_DEBUG 1

different log levels

debugging information

Referenced by osmo_vlogp().

#define LOGP | ( |  | ss,
|  |  | level,
|  |  | fmt,
|  |  | args...
| ) |  | logp2(ss, level, __FILE__, __LINE__, 0, fmt, ##args)

Log a new message through the Osmocom logging framework.

Parameters

  [in] | ss | logging subsystem (e.g. DLGLOBAL)
  [in] | level | logging level (e.g. LOGL_NOTICE)
  [in] | fmt | format string
  [in] | args | variable argument list

Referenced by osmo_log_backtrace().

#define LOGPC | ( |  | ss,
|  |  | level,
|  |  | fmt,
|  |  | args...
| ) |  | logp2(ss, level, __FILE__, __LINE__, 1, fmt, ##args)

Continue a log message through the Osmocom logging framework.

Parameters

  [in] | ss | logging subsystem (e.g. DLGLOBAL)
  [in] | level | logging level (e.g. LOGL_NOTICE)
  [in] | fmt | format string
  [in] | args | variable argument list

## Enumeration Type Documentation

enum log_target_type

Type of logging target.

Enumerator
LOG_TGT_TYPE_VTY | VTY logging.
LOG_TGT_TYPE_SYSLOG | syslog based logging
LOG_TGT_TYPE_FILE | text file logging
LOG_TGT_TYPE_STDERR | stderr logging
LOG_TGT_TYPE_STRRB | osmo_strrb-backed logging

## Function Documentation

void log_add_target | ( | struct log_target * | target | ) |

Register a new log target with the logging core.

Parameters

  [in] | target | Log target to be registered

References log_target::entry.

Referenced by osmo_init_logging().

void log_del_target | ( | struct log_target * | target | ) |

Unregister a log target from the logging core.

Parameters

  [in] | target | Log target to be unregistered

References log_target::entry.

Referenced by log_target_destroy().

void int log_init | ( | const struct log_info * | inf,
|  | void * | ctx
| ) |  |

Initialize the Osmocom logging core.

Parameters

  [in] | inf | Information regarding logging categories
  [in] | ctx | talloc context for logging allocations

Returns
  0 in case of success, negative in case of error

References ARRAY_SIZE, log_info::cat, log_info::num_cat, and log_info::num_cat_user.

Referenced by osmo_init_logging().

int log_parse_category | ( | const char * | category | ) |

parse a human-readable log category into numeric form

Parameters

  [in] | category | human-readable log category name

Returns
  numeric category value, or -EINVAL otherwise

References log_info::cat, log_info_cat::name, and log_info::num_cat.

void log_parse_category_mask | ( | struct log_target * | target,
|  | const char * | _mask
| ) |  |

parse the log category mask

Parameters

  [in] | target | log target to be configured
  [in] | _mask | log category mask string

The format can be this: category1:category2:category3 or category1,2:category2,3:...

References log_info::cat, log_target::categories, log_info_cat::color, log_info_cat::name, log_info::num_cat, log_target::output, log_target::print_category, log_target::print_ext_timestamp, log_target::print_filename, log_target::print_timestamp, and log_target::use_color.

void log_set_all_filter | ( | struct log_target * | target,
|  | int | all
| ) |  |

Enable the LOG_FILTER_ALL log filter.

Parameters

  [in] | target | Log target to be affected
  [in] | all | enable (1) or disable (0) the ALL filter

When the LOG_FILTER_ALL filter is enabled, all log messages will be printed. It acts as a wildcard. Setting it to 1 means there is no filtering.

References log_target::filter_map.

Referenced by osmo_init_logging().

void log_set_category_filter | ( | struct log_target * | target,
|  | int | category,
|  | int | enable,
|  | int | level
| ) |  |

Set a category filter on a given log target.

Parameters

  [in] | target | Log target to be affected
  [in] | category | Log category to be affected
  [in] | enable | whether to enable or disable the filter
  [in] | level | Log level of the filter

References log_target::categories, and log_info::num_cat.

int log_set_context | ( | uint8_t | ctx_nr,
|  | void * | value
| ) |  |

Set the logging context.

Parameters

  [in] | ctx_nr | logging context number
  [in] | value | value to which the context is to be set

A logging context is something like the subscriber identity to which the currently processed message relates, or the BTS through which it was received. As soon as this data is known, it can be set using this function. The main use of context information is for logging filters.

References LOG_MAX_CTX.

void log_set_log_level | ( | struct log_target * | target,
|  | int | log_level
| ) |  |

Set the global log level for a given log target.

Parameters

  [in] | target | Log target to be affected
  [in] | log_level | New global log level

References log_target::loglevel.

void log_set_print_category | ( | struct log_target * | target,
|  | int | print_category
| ) |  |

Enable or disable printing of the category name.

Parameters

  [in] | target | Log target to be affected
  [in] | print_catname | Enable (1) or disable (0) filenames

Print the category/subsys name in front of every log message.

References log_target::print_category.

void log_set_print_extended_timestamp | ( | struct log_target * | target,
|  | int | print_timestamp
| ) |  |

Enable or disable printing of extended timestamps while logging.

Parameters

  [in] | target | Log target to be affected
  [in] | print_timestamp | Enable (1) or disable (0) timestamps

When both timestamp and extended timestamp is enabled then only the extended timestamp will be used. The format of the timestamp is YYYYMMDDhhmmssnnn.

References log_target::print_ext_timestamp.

void log_set_print_filename | ( | struct log_target * | target,
|  | int | print_filename
| ) |  |

Enable or disable printing of the filename while logging.

Parameters

  [in] | target | Log target to be affected
  [in] | print_filename | Enable (1) or disable (0) filenames

References log_target::print_filename.

void log_set_print_timestamp | ( | struct log_target * | target,
|  | int | print_timestamp
| ) |  |

Enable or disable printing of timestamps while logging.

Parameters

  [in] | target | Log target to be affected
  [in] | print_timestamp | Enable (1) or disable (0) timestamps

References log_target::print_timestamp.

void log_set_use_color | ( | struct log_target * | target,
|  | int | use_color
| ) |  |

Enable or disable the use of colored output.

Parameters

  [in] | target | Log target to be affected
  [in] | use_color | Use color (1) or don't use color (0)

References log_target::use_color.

struct log_target* log_target_create_file | ( | const char * | fname | ) |

Create a new file-based log target.

Parameters

  [in] | fname | File name of the new log file

Returns
  Log target in case of success, NULL otherwise

References log_target_create(), LOG_TGT_TYPE_FILE, log_target::output, and log_target::type.

struct log_target* log_target_create_rb | ( | size_t | size | ) |

Create a new logging target for ringbuffer-backed logging.

Parameters

  [in] | size | The capacity (number of messages) of the logging target.

Returns
  A log target in case of success, NULL in case of error.

References log_target_create(), log_target_destroy(), LOG_TGT_TYPE_STRRB, osmo_strrb_create(), log_target::output, and log_target::type.

struct log_target * log_target_create_syslog | ( | const char * | ident,
|  | int | option,
|  | int | facility
| ) |  |

Create a new logging target for syslog logging.

Parameters

  [in] | ident | syslog string identifier
  [in] | option | syslog options
  [in] | facility | syslog facility

Returns
  Log target in case of success, NULL in case of error

References log_target_create(), LOG_TGT_TYPE_SYSLOG, log_target::output, and log_target::type.

struct log_target* log_target_find | ( | int | type,
|  | const char * | fname
| ) |  |

Find a registered log target.

Parameters

  [in] | type | Log target type
  [in] | fname | File name

Returns
  Log target (if found), NULL otherwise

References log_target::entry, LOG_TGT_TYPE_FILE, and log_target::type.

size_t log_target_rb_avail_size | ( | struct log_target const * | target | ) |

Return the capacity of the osmo_strrb-backed target.

Parameters

  [in] | target | The target to search.

Note that this is the capacity (aka max number of messages). It is not the number of unused message slots.

Returns
  The number of log strings in the osmo_strrb-backed target.

References osmo_strrb::size.

const char* log_target_rb_get | ( | struct log_target const * | target,
|  | size_t | logindex
| ) |  |

Return the nth log entry in a target.

Parameters

  [in] | target | The target to search.
  [in] | logindex | The index of the log entry/error message.

Returns
  A pointer to the nth message, or NULL if logindex is invalid.

References osmo_strrb_get_nth().

size_t log_target_rb_used_size | ( | struct log_target const * | target | ) |

Return the number of log strings in the osmo_strrb-backed target.

Parameters

  [in] | target | The target to search.

Returns
  The number of log strings in the osmo_strrb-backed target.

References osmo_strrb_elements().

const char* log_vty_command_description | ( | const struct log_info * | unused_info | ) |

Generates the logging command description for VTY.

Parameters

  [in] | unused_info | Deprecated parameter, no longer used!

References log_info::cat, log_info_cat::description, log_info_cat::name, and log_info::num_cat.

const char* log_vty_command_string | ( | const struct log_info * | unused_info | ) |

Generates the logging command string for VTY.

Parameters

  [in] | unused_info | Deprecated parameter, no longer used!

References log_info::cat, log_info_cat::name, and log_info::num_cat.